package sun.net.httpserver;

import java.util.Iterator;
import java.util.LinkedList;

class ContextList
{
    static final int MAX_CONTEXTS = 50;
    LinkedList<HttpContextImpl> list;
    
    ContextList() {
        this.list = new LinkedList();
    }
    
    public synchronized void add(HttpContextImpl e) {
        assert e.getPath() != null;
        this.list.add(e);
        return;
    }
    
    public synchronized int size() {
        return this.list.size();
    }
    
    synchronized HttpContextImpl findContext(String s, String s2) {
        return this.findContext(s, s2, false);
    }
    
    synchronized HttpContextImpl findContext(String lowerCase, String anObject, boolean b) {
        lowerCase = lowerCase.toLowerCase();
        String s = "";
        HttpContextImpl httpContextImpl = null;
        for (HttpContextImpl httpContextImpl2 : this.list) {
            if (!httpContextImpl2.getProtocol().equals(lowerCase)) {
                continue;
            }
            String path = httpContextImpl2.getPath();
            if (b && !path.equals(anObject)) {
                continue;
            }
            if (!b && !anObject.startsWith(path)) {
                continue;
            }
            if (path.length() > s.length()) {
                s = path;
                httpContextImpl = httpContextImpl2;
            }
            else {
                continue;
            }
        }
        return httpContextImpl;
    }
    
    public synchronized void remove(String s, String s2) throws IllegalArgumentException {
        HttpContextImpl context = this.findContext(s, s2, true);
        if (context == null) {
            throw new IllegalArgumentException("cannot remove element from list");
        }
        this.list.remove(context);
        return;
    }
    
    public synchronized void remove(HttpContextImpl obj) throws IllegalArgumentException {
        for (HttpContextImpl o : this.list) {
            if (o.equals(obj)) {
                this.list.remove(o);
                return;
            }
            continue;
        }
        throw new IllegalArgumentException("no such context in list");
    }
}
